!  Mc_method.f90 
!
!  FUNCTIONS:
!  Mc_method - Entry point of console application.
!

!****************************************************************************
!
!  PROGRAM: Mc_method
!
!  PURPOSE:  Entry point for the console application.
!
!**************************************************************************** 
SUBROUTINE Mc_method( N           ,&          ! ݵ              //
                    Q1          ,&          !                           //
                    Q20         ,&        ! ʼֵ                       //     
                    X           ,&          !                      //
                    K           ,&          ! ģ                           //
                    DETAT       ,&          ! ʱ䲽      Сʱ                 //
                    C0          ,&          ! ϵ                                //  
                    C1          ,&          !                                    //  
                    C2          ,&           !                                     //  
                    Q2          )           !                                   //

    INTEGER::NFILENAME
    CHARACTER(LEN = NFILENAME)::FILENAME

    INTEGER::N
    REAL::Q1(1000)
    REAL::Q20
    REAL::Q2(1000)
    REAL::I1
    REAL::I2
    REAL::C0
    REAL::C1
    REAL::C2

    REAL::X
    REAL::K
    REAL::DETAT
    
    INTEGER::I
    
    C0 = (0.5*DETAT - K*X)/(0.5*DETAT + K - K*X)
    C1 = (0.5*DETAT + K*X)/(0.5*DETAT + K - K*X) 
    C2 = (-0.5*DETAT +K - K*X)/(0.5*DETAT + K - K*X)  
    
    Q2(1) =Q20    
    
    DO I = 2,N
        
        I2 = Q1(I)
        
        I1 = Q1(I-1)
        
        Q2(I) = C0*I2 + C1*I1 + C2*Q2(I-1)
    
    END DO
    
    
END SUBROUTINE Mc_method

